diff -r 779c5a44c6a1 src/company_gui.cpp
--- a/src/company_gui.cpp	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/company_gui.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -28,6 +28,10 @@
 #include "date_func.h"
 #include "widgets/dropdown_type.h"
 #include "tilehighlight_func.h"
+#include "company_gui.h"
+#include "currency.h"
+#include "openttd.h"
+#include "window_func.h"
 
 #include "table/strings.h"
 
@@ -40,8 +44,9 @@
 };
 
 static void DoSelectCompanyManagerFace(Window *parent);
+static void ShowCompanySharingSettings(CompanyID company);
 
-/** Standard unsorted list of expenses. */
+/** Standard unsorted list of expenses with infrastructure sharing disabled. */
 static ExpensesType _expenses_list_1[] = {
 	EXPENSES_CONSTRUCTION,
 	EXPENSES_NEW_VEHICLES,
@@ -58,7 +63,7 @@
 	EXPENSES_OTHER,
 };
 
-/** Grouped list of expenses. */
+/** Grouped list of expenses with infrastructure sharing disabled. */
 static ExpensesType _expenses_list_2[] = {
 	EXPENSES_TRAIN_INC,
 	EXPENSES_ROADVEH_INC,
@@ -78,6 +83,47 @@
 	INVALID_EXPENSES,
 };
 
+/** Standard unsorted list of expenses with infrastructure sharing enabled. */
+static ExpensesType _expenses_list_3[] = {
+	EXPENSES_CONSTRUCTION,
+	EXPENSES_NEW_VEHICLES,
+	EXPENSES_TRAIN_RUN,
+	EXPENSES_ROADVEH_RUN,
+	EXPENSES_AIRCRAFT_RUN,
+	EXPENSES_SHIP_RUN,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_PROPERTY,
+	EXPENSES_TRAIN_INC,
+	EXPENSES_ROADVEH_INC,
+	EXPENSES_AIRCRAFT_INC,
+	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INC,
+	EXPENSES_LOAN_INT,
+	EXPENSES_OTHER,
+};
+
+/** Grouped list of expenses with infrastructure sharing enabled. */
+static ExpensesType _expenses_list_4[] = {
+	EXPENSES_TRAIN_INC,
+	EXPENSES_ROADVEH_INC,
+	EXPENSES_AIRCRAFT_INC,
+	EXPENSES_SHIP_INC,
+	EXPENSES_SHARED_INC,
+	INVALID_EXPENSES,
+	EXPENSES_TRAIN_RUN,
+	EXPENSES_ROADVEH_RUN,
+	EXPENSES_AIRCRAFT_RUN,
+	EXPENSES_SHIP_RUN,
+	EXPENSES_SHARED_RUN,
+	EXPENSES_PROPERTY,
+	EXPENSES_LOAN_INT,
+	INVALID_EXPENSES,
+	EXPENSES_CONSTRUCTION,
+	EXPENSES_NEW_VEHICLES,
+	EXPENSES_OTHER,
+	INVALID_EXPENSES,
+};
+
 /** Expense list container. */
 struct ExpensesList {
 	const ExpensesType *et;   ///< Expenses items.
@@ -117,6 +163,8 @@
 static const ExpensesList _expenses_list_types[] = {
 	ExpensesList(_expenses_list_1, lengthof(_expenses_list_1), 0),
 	ExpensesList(_expenses_list_2, lengthof(_expenses_list_2), 3),
+	ExpensesList(_expenses_list_3, lengthof(_expenses_list_3), 0),
+	ExpensesList(_expenses_list_4, lengthof(_expenses_list_4), 3),
 };
 
 /** Widgets of the company finances windows. */
@@ -152,7 +200,7 @@
 	DrawString(r.left, r.right, y, STR_FINANCES_EXPENDITURE_INCOME_TITLE, TC_FROMSTRING, SA_CENTER, true);
 	y += FONT_HEIGHT_NORMAL + EXP_LINESPACE;
 
-	int type = _settings_client.gui.expenses_layout;
+	int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2 : _settings_client.gui.expenses_layout;
 	for (uint i = 0; i < _expenses_list_types[type].length; i++) {
 		const ExpensesType et = _expenses_list_types[type].et[i];
 		if (et == INVALID_EXPENSES) {
@@ -201,7 +249,7 @@
 
 	Money sum = 0;
 	Money subtotal = 0;
-	int type = _settings_client.gui.expenses_layout;
+	int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2: _settings_client.gui.expenses_layout;
 	for (uint i = 0; i < _expenses_list_types[type].length; i++) {
 		const ExpensesType et = _expenses_list_types[type].et[i];
 		if (et == INVALID_EXPENSES) {
@@ -315,7 +363,7 @@
 
 	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
 	{
-		int type = _settings_client.gui.expenses_layout;
+		int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2: _settings_client.gui.expenses_layout;
 		switch (widget) {
 			case CFW_EXPS_CATEGORY:
 				size->width  = _expenses_list_types[type].GetCategoriesWidth();
@@ -404,7 +452,7 @@
 	{
 		if (!small) {
 			/* Check that the expenses panel height matches the height needed for the layout. */
-			int type = _settings_client.gui.expenses_layout;
+			int type = _settings_game.sharing.sharing_mode != SHARING_NONE ? _settings_client.gui.expenses_layout + 2 : _settings_client.gui.expenses_layout;
 			if (_expenses_list_types[type].GetHeight() != this->GetWidget<NWidgetBase>(CFW_EXPS_CATEGORY)->current_y) {
 				this->SetupWidgets();
 				this->ReInit();
@@ -1571,6 +1619,8 @@
 	CW_WIDGET_COLOUR_SCHEME,
 	CW_WIDGET_PRESIDENT_NAME,
 	CW_WIDGET_COMPANY_NAME,
+	CW_WIDGET_SELECT_SHARING,     ///< View/hide the 'sharing' button.
+	CW_WIDGET_SHARING,            ///< Button to open the infrastructure sharing window.
 	CW_WIDGET_BUY_SHARE,
 	CW_WIDGET_SELL_SHARE,
 
@@ -1624,6 +1674,10 @@
 							NWidget(WWT_TEXTBTN, COLOUR_GREY, CW_WIDGET_RELOCATE_HQ), SetFill(1, 0), SetDataTip(STR_COMPANY_VIEW_RELOCATE_HQ, STR_COMPANY_VIEW_RELOCATE_COMPANY_HEADQUARTERS),
 							NWidget(NWID_SPACER), SetMinimalSize(90, 0),
 						EndContainer(),
+						NWidget(NWID_SELECTION, INVALID_COLOUR, CW_WIDGET_SELECT_SHARING),
+							NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, CW_WIDGET_SHARING), SetFill(1, 0), SetDataTip(STR_COMPANY_VIEW_SHARING_BUTTON, STR_COMPANY_VIEW_SHARING_TOOLTIP),
+							NWidget(NWID_SPACER), SetMinimalSize(90, 0),
+						EndContainer(),
 						NWidget(NWID_SPACER), SetFill(0, 1),
 					EndContainer(),
 				EndContainer(),
@@ -1696,6 +1750,10 @@
 		CWP_RELOCATE_SHOW = 0, ///< Show the relocate HQ button.
 		CWP_RELOCATE_HIDE,     ///< Hide the relocate HQ button.
 
+		/* Display planes of the #CW_WIDGET_SELECT_SHARING selection widget. */
+		CWP_SHARING_SHOW = 0, ///< Show the sharing button.
+		CWP_SHARING_HIDE,     ///< Hide the sharing button.
+
 		/* Display planes of the #CW_WIDGET_SELECT_BUTTONS selection widget. */
 		CWP_BUTTONS_LOCAL = 0, ///< Buttons of the local company.
 		CWP_BUTTONS_OTHER,     ///< Buttons of the other companies.
@@ -1741,6 +1799,15 @@
 			return;
 		}
 
+		/* Enable/disable 'Sharing' button. */
+		plane = (_settings_game.sharing.sharing_mode == SHARING_INDIVIDUAL) ? CWP_SHARING_SHOW : CWP_SHARING_HIDE;
+		wi = this->GetWidget<NWidgetStacked>(CW_WIDGET_SELECT_SHARING);
+		if (plane != wi->shown_plane) {
+			wi->SetDisplayedPlane(plane);
+			this->SetDirty();
+			return;
+		}
+
 		/* Multiplayer buttons. */
 		plane = ((!_networking) ? CWP_MP_EMPTY : (local ? CWP_MP_C_PWD : CWP_MP_C_JOIN));
 		wi = this->GetWidget<NWidgetStacked>(CW_WIDGET_SELECT_MULTIPLAYER);
@@ -1946,6 +2013,10 @@
 				DoCommandP(0, this->window_number, 0, CMD_SELL_SHARE_IN_COMPANY | CMD_MSG(STR_ERROR_CAN_T_SELL_25_SHARE_IN));
 				break;
 
+			case CW_WIDGET_SHARING:
+				ShowCompanySharingSettings((CompanyID)this->window_number);
+				break;
+
 #ifdef ENABLE_NETWORK
 			case CW_WIDGET_COMPANY_PASSWORD:
 				if (this->window_number == _local_company) ShowNetworkCompanyPasswordWindow(this);
@@ -2135,3 +2206,521 @@
 {
 	AllocateWindowDescFront<BuyCompanyWindow>(&_buy_company_desc, company);
 }
+
+/** Some constants used when creating the main panel widgets */
+enum SharingWindowConstants {
+	SWC_NUM_VEHTYPES       = 4,  ///< Number of vehicle types to be displayed
+	SWC_NUM_COMPANIES      = MAX_COMPANIES - 1, ///< Max number of companies to be displayed
+
+	SWC_MARGIN_TOP_BOTTOM  = 5,  ///< Margin between top/bottom edge of the panel and the widgets
+	SWC_MARGIN_LEFT_RIGHT  = 5,  ///< Margin between left/right edge of the panel and the widgets
+	SWC_MARGIN_COLUMNS     = 10, ///< Margin between two columns
+	SWC_MARGIN_LINES       = 2,  ///< Margin between two text lines
+	SWC_MARGIN_BLOCKS      = 8,  ///< Margin between two groups of lines (e.g. between two sets of lines belonging to two vehicle types)
+	SWC_EXTRA_BUTTON_WIDTH = 12, ///< Extra width for buttons, beyond the normal text width
+};
+
+/** per-company sharing settings window */
+enum SharingSettingsWidgets {
+	SSW_CAPTION,        ///< Caption
+	SSW_ICON_PANEL,     ///< Empty widget to draw the train/plane/ship icons on
+	SSW_SELECT_TEXTS,   ///< Selection widget to switch texts column between tabs
+	SSW_SELECT_CURRENT, ///< Selection widget to switch current settings column between tabs
+	SSW_SELECT_FUTURE,  ///< Selection widget to switch future column between tabs
+	SSW_CHANGES_EFFECT, ///< 'Changes take effect in' text widget
+	SSW_OPTIONS,        ///< Options button, switches to the options tab
+	SSW_COMPANIES,      ///< Companies button, switches to the companies tab
+	SSW_OPTION_FIRST,   ///< First widget index of the widgets on the options tab
+
+	/* The following widgets are each repeated SWC_NUM_VEHTYPES times */
+	SSW_OPTION_TEXT_OPTION    = SSW_OPTION_FIRST,                              ///< Text describing the sharing option (e.g. 'Enable sharing of train tracks')
+	SSW_OPTION_CURRENT_OPTION = SSW_OPTION_TEXT_OPTION    + SWC_NUM_VEHTYPES,  ///< Label telling whether the current setting is On or Off
+	SSW_OPTION_FUTURE_OPTION  = SSW_OPTION_CURRENT_OPTION + SWC_NUM_VEHTYPES,  ///< Button to toggle the future setting between On and Off
+	SSW_OPTION_TEXT_FEE       = SSW_OPTION_FUTURE_OPTION  + SWC_NUM_VEHTYPES,  ///< Text describing the sharing fee (e.g. 'Monthly toll for trains')
+	SSW_OPTION_CURRENT_FEE    = SSW_OPTION_TEXT_FEE       + SWC_NUM_VEHTYPES,  ///< Label to display the current fee
+	SSW_OPTION_FUTURE_FEE_INC = SSW_OPTION_CURRENT_FEE    + SWC_NUM_VEHTYPES,  ///< Button to increment the (future) fee
+	SSW_OPTION_FUTURE_FEE_DEC = SSW_OPTION_FUTURE_FEE_INC + SWC_NUM_VEHTYPES,  ///< Button to decrement the (future) fee
+	SSW_OPTION_FUTURE_FEE     = SSW_OPTION_FUTURE_FEE_DEC + SWC_NUM_VEHTYPES,  ///< Widget that shows the future fee
+
+	SSW_COMPANY_FIRST         = SSW_OPTION_FUTURE_FEE     + SWC_NUM_VEHTYPES,  ///< First widget index on the companies tab
+	/* the following widgets are each repeated SWC_NUM_COMPANIES times */
+	SSW_COMPANY_NAME          = SSW_COMPANY_FIRST,                             ///< Text widget displaying the company name
+	SSW_COMPANY_CURRENT       = SSW_COMPANY_NAME          + SWC_NUM_COMPANIES, ///< Label displaying whether the company is currently allowed or not
+	SSW_COMPANY_FUTURE        = SSW_COMPANY_CURRENT       + SWC_NUM_COMPANIES, ///< Button to toggle whether the company will be allowed in the future
+};
+
+/** Window that shows per-company infrastructure sharing settings and allows changing them */
+struct SharingSettingsWindow : public Window {
+private:
+	static const int SHARING_FEE_STEPSIZE = 10;  ///< Stepsize when incrementing or decrementing the sharing fee.
+
+	Company *company;         ///< The company this window belongs to
+	bool companies_tab;       ///< Is the companies tab currently open?
+	uint8 current_query_type; ///< type of vehicle for which a querystring window is open.
+
+	/**
+	 * Seperate a widget number into two parts:
+	 *  - A 'base' from the SharingSettingsWidgets enum, this defines the type of widget.
+	 *  - An 'index' which gives the VehicleType or CompanyID this widget is associated with.
+	 * @param widget The widget number.
+	 * @param index Pointer to the resulting 'index' (see above).
+	 * @return The new 'base' widget number (see above).
+	 */
+	int GetWidgetBaseAndIndex(int widget, int *index) const
+	{
+		int line = 0;
+		if (IsInsideMM(widget, SSW_OPTION_FIRST, SSW_COMPANY_FIRST)) {
+			line = (widget - SSW_OPTION_FIRST) % SWC_NUM_VEHTYPES;
+			*index = line;
+		} else if (widget >= SSW_COMPANY_FIRST) {
+			line = (widget - SSW_COMPANY_FIRST) % SWC_NUM_COMPANIES;
+			/* Determine which compny is shown on that line */
+			int i = 0;
+			*index = INVALID_COMPANY;
+			for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+				if (Company::IsValidID(c) && c != this->company->index && i++ == line) {
+					*index = c;
+				}
+			}
+		}
+		return widget - line;
+	}
+
+public:
+	/** Constructor */
+	SharingSettingsWindow(const WindowDesc *desc, WindowNumber number) : Window()
+	{
+		this->company = Company::GetIfValid(number);
+		assert(this->company != NULL);
+
+		this->CreateNestedTree(desc, true);
+		this->FinishInitNested(desc, number);
+
+		/* Set this->owner after initializing the nested widgets. Don't use it anywhere in the code for widget resizing etc. ! */
+		this->owner = (Owner)number;
+
+		this->DisableWidget(SSW_OPTIONS);
+		this->InvalidateData();
+	}
+
+	virtual void OnInit()
+	{
+		int num_companies = Company::GetNumItems() - 1;
+		for (int i = 0; i < SWC_NUM_COMPANIES; i++) {
+			this->GetWidget<NWidgetBase>(SSW_COMPANY_FUTURE + i)->type = (i < num_companies) ? WWT_TEXTBTN : WWT_EMPTY;
+		}
+	}
+
+	virtual void OnPaint()
+	{
+		this->DrawWidgets();
+	}
+
+	virtual void SetStringParameters(int widget) const
+	{
+		/* Empty string as default parameter */
+		SetDParam(0, STR_EMPTY);
+		int index;
+		switch (this->GetWidgetBaseAndIndex(widget, &index)) {
+			case SSW_CAPTION:
+				SetDParam(0, this->company->index);
+				break;
+			case SSW_CHANGES_EFFECT:
+				if (this->company->sharing_delay != 0) {
+					SetDParam(0, STR_SHARING_CHANGES_TAKE_EFFECT);
+					SetDParam(1, this->company->sharing_delay);
+				}
+				break;
+			case SSW_OPTION_CURRENT_OPTION:
+				SetDParam(0, this->company->sharing_current.IsSharingAllowed((VehicleType)index) ? STR_SHARING_VALUE_ALLOWED : STR_SHARING_VALUE_NOT_ALLOWED);
+				break;
+			case SSW_OPTION_FUTURE_OPTION:
+				SetDParam(0, this->company->sharing_future.IsSharingAllowed((VehicleType)index) ? STR_SHARING_VALUE_ALLOWED : STR_SHARING_VALUE_NOT_ALLOWED);
+				break;
+			case SSW_OPTION_CURRENT_FEE:
+				SetDParam(0, this->company->sharing_current.GetSharingFee((VehicleType)index));
+				break;
+			case SSW_OPTION_FUTURE_FEE:
+				SetDParam(0, this->company->sharing_future.GetSharingFee((VehicleType)index));
+				break;
+			case SSW_COMPANY_NAME:
+				if (index != INVALID_COMPANY) {
+					SetDParam(0, STR_SHARING_SETTING_COMPANY);
+					SetDParam(1, index);
+				} else if (widget == SSW_COMPANY_NAME) {
+					/* if no companies at all, draw 'No other companies' on the first line */
+					SetDParam(0, STR_SHARING_SETTING_NO_COMPANIES);
+				}
+				break;
+			case SSW_COMPANY_CURRENT:
+				if (index != INVALID_COMPANY) SetDParam(0, this->company->sharing_current.IsCompanyAllowed((CompanyID)index) ? STR_SHARING_VALUE_ALLOWED : STR_SHARING_VALUE_NOT_ALLOWED);
+				break;
+			case SSW_COMPANY_FUTURE:
+				if (index != INVALID_COMPANY) SetDParam(0, this->company->sharing_future.IsCompanyAllowed((CompanyID)index) ? STR_SHARING_VALUE_ALLOWED : STR_SHARING_VALUE_NOT_ALLOWED);
+				break;
+		}
+	}
+
+	virtual void DrawWidget(const Rect &r, int widget) const
+	{
+		if (widget != SSW_ICON_PANEL) return;
+		if (this->companies_tab) {
+			int line = 0;
+			int y_offset = (int)(this->GetWidget<NWidgetBase>(SSW_COMPANY_NAME)->current_y - GetSpriteSize(SPR_COMPANY_ICON).height) / 2;
+			for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+				if (Company::IsValidID(c) && c != this->company->index) DrawCompanyIcon(c, r.left, this->GetWidget<NWidgetBase>(SSW_COMPANY_NAME + line++)->pos_y + y_offset);
+			}
+		} else {
+			VehicleType type;
+			FOR_ALL_SHARING_VEHTYPES(type) {
+				int y_size   = this->GetWidget<NWidgetBase>(SSW_OPTION_TEXT_FEE)->pos_y + this->GetWidget<NWidgetBase>(SSW_OPTION_TEXT_FEE)->current_y - this->GetWidget<NWidgetBase>(SSW_OPTION_TEXT_OPTION)->pos_y;
+				int y_offset = (y_size - (int)GetSpriteSize(SPR_IMG_TRAINLIST + type).height) / 2;
+				DrawSprite(SPR_IMG_TRAINLIST + type, PAL_NONE, r.left, this->GetWidget<NWidgetBase>(SSW_OPTION_TEXT_OPTION + type)->pos_y + y_offset);
+			}
+		}
+	}
+
+	virtual void UpdateWidgetSize(int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
+	{
+		/* determine the height of a line, which is max(height of [<][>] buttons, height of [text] button) */
+		uint line_height = max<uint>(GetSpriteSize(SPR_ARROW_LEFT).height + WD_IMGBTN_TOP + WD_IMGBTN_BOTTOM, FONT_HEIGHT_NORMAL + WD_FRAMERECT_TOP + WD_FRAMERECT_BOTTOM);
+
+		int index;
+		int base = this->GetWidgetBaseAndIndex(widget, &index);
+		switch (base) {
+			case SSW_ICON_PANEL:
+				VehicleType type;
+				FOR_ALL_SHARING_VEHTYPES(type) {
+					size->width = max(size->width, GetSpriteSize(SPR_IMG_TRAINLIST + type).width);
+				}
+				size->width = max(size->width, GetSpriteSize(SPR_COMPANY_ICON).width);
+				break;
+			case SSW_OPTION_TEXT_OPTION:
+			case SSW_OPTION_TEXT_FEE:
+			case SSW_COMPANY_NAME:
+				/* Always leave the first company name widget visible to show 'no other companies' */
+				size->height = (index != INVALID_COMPANY || widget == SSW_COMPANY_NAME) ? line_height : 0;
+				break;
+			case SSW_OPTION_CURRENT_OPTION:
+			case SSW_OPTION_FUTURE_OPTION:
+			case SSW_COMPANY_CURRENT:
+			case SSW_COMPANY_FUTURE:
+				size->height = (index != INVALID_COMPANY) ? line_height : 0;
+				size->width = maxdim(GetStringBoundingBox(STR_SHARING_VALUE_ALLOWED), GetStringBoundingBox(STR_SHARING_VALUE_NOT_ALLOWED)).width + padding.width;
+				if (base == SSW_OPTION_FUTURE_OPTION || base == SSW_COMPANY_FUTURE) size->width += SWC_EXTRA_BUTTON_WIDTH;
+				break;
+			case SSW_OPTION_CURRENT_FEE:
+			case SSW_OPTION_FUTURE_FEE:
+				size->height = line_height;
+				SetDParam(0, MAX_SHARING_FEE);
+				size->width = GetStringBoundingBox(STR_FINANCES_TOTAL_CURRENCY).width;
+				if (base == SSW_OPTION_FUTURE_FEE) size->width += SWC_EXTRA_BUTTON_WIDTH;
+				break;
+		}
+	}
+
+	virtual void OnClick(Point pt, int widget)
+	{
+		if (this->owner != _local_company && widget != SSW_OPTIONS && widget != SSW_COMPANIES) return;
+		int index;
+		switch (this->GetWidgetBaseAndIndex(widget, &index)) {
+			case SSW_OPTIONS:
+			case SSW_COMPANIES:
+				/* Switch to options / companies tab */
+				this->companies_tab = (widget == SSW_COMPANIES);
+				this->SetWidgetDisabledState(SSW_OPTIONS, !this->companies_tab);
+				this->SetWidgetDisabledState(SSW_COMPANIES, this->companies_tab);
+				for (int sel_widget = SSW_SELECT_TEXTS; sel_widget <= SSW_SELECT_FUTURE; sel_widget++) {
+					this->GetWidget<NWidgetStacked>(sel_widget)->SetDisplayedPlane(this->companies_tab);
+				}
+				this->SetDirty();
+				break;
+			case SSW_OPTION_FUTURE_OPTION:
+				DoCommandP(0, MODIFY_SHARING_OPTION | (index << 8), !this->company->sharing_future.IsSharingAllowed((VehicleType)index), CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+				break;
+			case SSW_OPTION_FUTURE_FEE_DEC: {
+				int value = this->company->sharing_future.GetSharingFee((VehicleType)index);
+				value =  value - min(value, SHARING_FEE_STEPSIZE);
+				DoCommandP(0, MODIFY_SHARING_FEE | (index << 8), value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+			} break;
+			case SSW_OPTION_FUTURE_FEE_INC: {
+				int value = this->company->sharing_future.GetSharingFee((VehicleType)index);
+				value = min(MAX_SHARING_FEE, value + SHARING_FEE_STEPSIZE);
+				DoCommandP(0, MODIFY_SHARING_FEE | (index << 8), value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+			} break;
+			case SSW_OPTION_FUTURE_FEE:
+				/* delete any old query string window */
+				DeleteWindowByClass(WC_QUERY_STRING);
+				this->RaiseWidget(SSW_OPTION_FUTURE_FEE + this->current_query_type);
+				this->SetWidgetDirty(SSW_OPTION_FUTURE_FEE + this->current_query_type);
+
+				this->current_query_type = index;
+				this->LowerWidget(SSW_OPTION_FUTURE_FEE + index);
+				this->SetWidgetDirty(SSW_OPTION_FUTURE_FEE + index);
+				SetDParam(0, this->company->sharing_future.GetSharingFee((VehicleType)index) * _currency->rate);
+				ShowQueryString(STR_JUST_INT, STR_SHARING_CHANGE_FEE_CAPTION, 10, 0, this, CS_NUMERAL, QSF_NONE);
+				break;
+			case SSW_COMPANY_FUTURE:
+				if (index != INVALID_COMPANY) {
+					DoCommandP(0, MODIFY_SHARING_COMPANIES | (index << 8), !this->company->sharing_future.IsCompanyAllowed((CompanyID)index), CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+				}
+				break;
+		}
+	}
+
+	virtual void OnInvalidateData(int data)
+	{
+		if (data != 0) {
+			/* number of companies got changed */
+			this->ReInit();
+		}
+		CompanySharingSettings *settings = &this->company->sharing_future;
+		VehicleType type;
+		FOR_ALL_SHARING_VEHTYPES(type) {
+			/* set option button state */
+			this->SetWidgetLoweredState(SSW_OPTION_FUTURE_OPTION + type, settings->IsSharingAllowed(type));
+			/* enable / disable buttons to increase/decrease the fee */
+			this->SetWidgetDisabledState(SSW_OPTION_FUTURE_FEE_INC + type, settings->GetSharingFee(type) >= MAX_SHARING_FEE);
+			this->SetWidgetDisabledState(SSW_OPTION_FUTURE_FEE_DEC + type, settings->GetSharingFee(type) == 0);
+		}
+
+		/* set buttons on the companies tab */
+		int line = 0;
+		for (CompanyID c = COMPANY_FIRST; c < MAX_COMPANIES; c++) {
+			if (Company::IsValidID(c) && c != this->company->index) this->SetWidgetLoweredState(SSW_COMPANY_FUTURE + line++, settings->IsCompanyAllowed(c));
+		}
+	}
+
+	virtual void OnQueryTextFinished(char *str)
+	{
+		this->RaiseWidget(SSW_OPTION_FUTURE_FEE + this->current_query_type);
+		this->SetWidgetDirty(SSW_OPTION_FUTURE_FEE + this->current_query_type);
+
+		if (StrEmpty(str)) return;
+		int32 value = atoi(str);
+		value /= _currency->rate;
+		value = Clamp(value, 0, MAX_SHARING_FEE);
+		DoCommandP(0, MODIFY_SHARING_FEE | (this->current_query_type << 8), value, CMD_CHANGE_SHARING_SETTING | CMD_MSG(STR_ERROR_CAN_T_CHANGE_SHARING_SETTING));
+	}
+};
+
+/**
+ * Make a single widget for the option tab.
+ * @note in the case of SSW_OPTION_FUTURE_FEE, three widgets inside a single container are created instead of just one.
+ * @param biggest_index Biggest widget index.
+ * @param widget Widget number of the widget to make.
+ * @param type Vehicle type to make the widget for.
+ * @reutn The newly created widget.
+ */
+static NWidgetBase *MakeOptionWidget(int *biggest_index, int widget, VehicleType type)
+{
+	NWidgetLeaf *leaf;
+	*biggest_index = max(*biggest_index, widget + type);
+	switch (widget) {
+		case SSW_OPTION_TEXT_OPTION:
+		case SSW_OPTION_TEXT_FEE: {
+			/* Text string describing option/fee */
+			StringID str = (widget == SSW_OPTION_TEXT_FEE) ? (type == VEH_TRAIN ? STR_SHARING_SETTING_MONTHLY_TOLL : STR_SHARING_SETTING_FEE) : STR_SHARING_SETTING_RAIL + type;
+			leaf = new NWidgetLeaf(WWT_TEXT, COLOUR_GREY, widget + type, str, STR_NULL);
+		} break;
+		case SSW_OPTION_CURRENT_OPTION:
+		case SSW_OPTION_CURRENT_FEE:
+			/* Current setting of option/fee */
+			leaf = new NWidgetLeaf(WWT_LABEL, COLOUR_GREY, widget + type, widget == SSW_OPTION_CURRENT_FEE ? STR_FINANCES_TOTAL_CURRENCY : STR_JUST_STRING, STR_NULL);
+			break;
+		case SSW_OPTION_FUTURE_OPTION:
+			/* Future setting for option */
+			leaf = new NWidgetLeaf(WWT_TEXTBTN, COLOUR_YELLOW, widget + type, STR_JUST_STRING, STR_FINANCES_TOTAL_CURRENCY);
+			break;
+		case SSW_OPTION_FUTURE_FEE: {
+			NWidgetHorizontal *hor = new NWidgetHorizontal;
+			/* [<] button to decrease fee */
+			leaf = new NWidgetLeaf(NWID_BUTTON_ARROW, COLOUR_YELLOW, SSW_OPTION_FUTURE_FEE_DEC + type, AWV_DECREASE, STR_NULL);
+			hor->Add(leaf);
+			/* current fee, click to open query window */
+			leaf = new NWidgetLeaf(WWT_TEXTBTN, COLOUR_YELLOW, SSW_OPTION_FUTURE_FEE + type, STR_FINANCES_TOTAL_CURRENCY, STR_NULL);
+			leaf->SetFill(1, 0);
+			hor->Add(leaf);
+			/* [>] button to increase fee */
+			leaf = new NWidgetLeaf(NWID_BUTTON_ARROW, COLOUR_YELLOW, SSW_OPTION_FUTURE_FEE_INC + type, AWV_INCREASE, STR_NULL);
+			hor->Add(leaf);
+			/* return here */
+			return hor;
+		}
+		default: NOT_REACHED();
+	}
+	leaf->SetFill(1, 0);
+	return leaf;
+}
+
+/**
+ * Make an entire column of widgets for the options tab. The column contains two widgets per vehicle type.
+ * @param biggest_index Biggest widget index.
+ * @param widget1 Widget number of the first widget to create.
+ * @param widget2 Widget number of the second widget to create.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeOptionWidgetColumn(int *biggest_index, int widget1, int widget2)
+{
+	NWidgetVertical *vert = new NWidgetVertical;
+	vert->SetPIP(0, SWC_MARGIN_LINES, 0);
+	VehicleType type;
+	FOR_ALL_SHARING_VEHTYPES(type) {
+		/* Add extra space between blocks */
+		NWidgetSpacer *spacer = new NWidgetSpacer(0, SWC_MARGIN_BLOCKS - SWC_MARGIN_LINES);
+		vert->Add(spacer);
+		/* Add widgets */
+		vert->Add(MakeOptionWidget(biggest_index, widget1, type));
+		vert->Add(MakeOptionWidget(biggest_index, widget2, type));
+	}
+	return vert;
+}
+
+/**
+ * Create all the widgets for the 'Texts' column on the options tab.
+ * @param biggest_index Biggest widget index.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeOptionTextsColumn(int *biggest_index)
+{
+	return MakeOptionWidgetColumn(biggest_index, SSW_OPTION_TEXT_OPTION, SSW_OPTION_TEXT_FEE);
+}
+
+/**
+ * Create all the widgets for the 'Current settings' column on the options tab.
+ * @param biggest_index Biggest widget index.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeOptionCurrentColumn(int *biggest_index)
+{
+	return MakeOptionWidgetColumn(biggest_index, SSW_OPTION_CURRENT_OPTION, SSW_OPTION_CURRENT_FEE);
+}
+
+/**
+ * Create all the widgets for the 'Future settings' column on the options tab.
+ * @param biggest_index Biggest widget index.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeOptionFutureColumn(int *biggest_index)
+{
+	return MakeOptionWidgetColumn(biggest_index, SSW_OPTION_FUTURE_OPTION, SSW_OPTION_FUTURE_FEE);
+}
+
+/**
+ * Make an entire column of widgets for the companies tab. A column contains one widget per company.
+ * @param biggest_index Biggest widget index.
+ * @param widget Index of the (first) widget to create.
+ * @param tp The type of widget to create.
+ * @param colour The colour of the new widgets.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeCompanyWidgetColumn(int *biggest_index, int widget, WidgetType tp, Colours colour)
+{
+	NWidgetVertical *vert = new NWidgetVertical;
+	vert->SetPIP(SWC_MARGIN_BLOCKS, SWC_MARGIN_LINES, 0);
+
+	for (int i = 0; i < SWC_NUM_COMPANIES; i++) {
+		/* company name */
+		NWidgetLeaf *leaf = new NWidgetLeaf(tp, colour, widget + i, STR_JUST_STRING, STR_NULL);
+		leaf->SetFill(1, 0);
+		vert->Add(leaf);
+	}
+	*biggest_index = max(*biggest_index, widget + SWC_NUM_COMPANIES - 1);
+	return vert;
+}
+
+/**
+ * Create all the widgets for the 'Texts' column on the companies tab.
+ * @param biggest_index Biggest widget index.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeCompanyTextsColumn(int *biggest_index)
+{
+	return MakeCompanyWidgetColumn(biggest_index, SSW_COMPANY_NAME, WWT_TEXT, COLOUR_GREY);
+}
+
+/**
+ * Create all the widgets for the 'Current settings' column on the companies tab.
+ * @param biggest_index Biggest widget index.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeCompanyCurrentColumn(int *biggest_index)
+{
+	return MakeCompanyWidgetColumn(biggest_index, SSW_COMPANY_CURRENT, WWT_LABEL, COLOUR_GREY);
+}
+
+/**
+ * Create all the widgets for the 'Future settings' column on the companies tab.
+ * @param biggest_index Biggest widget index.
+ * @retun A container widget containing the newly created widgets.
+ */
+static NWidgetBase *MakeCompanyFutureColumn(int *biggest_index)
+{
+	return MakeCompanyWidgetColumn(biggest_index, SSW_COMPANY_FUTURE, WWT_TEXTBTN, COLOUR_YELLOW);
+}
+
+/** Nested widget tree for the sharing settings window. */
+static const NWidgetPart _nested_sharing_settings_widgets[] = {
+	NWidget(NWID_HORIZONTAL), // Window header
+		NWidget(WWT_CLOSEBOX, COLOUR_GREY), SetFill(0, 1),
+		NWidget(WWT_CAPTION, COLOUR_GREY, SSW_CAPTION), SetDataTip(STR_SHARING_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
+		NWidget(WWT_STICKYBOX, COLOUR_GREY), SetFill(0, 1),
+	EndContainer(),
+	NWidget(WWT_PANEL, COLOUR_GREY), SetDataTip(0x0, STR_SHARING_PANEL_TOOLTIP), SetPIP(SWC_MARGIN_TOP_BOTTOM, SWC_MARGIN_BLOCKS, SWC_MARGIN_TOP_BOTTOM), // Main Panel
+		NWidget(NWID_HORIZONTAL), SetPIP(SWC_MARGIN_LEFT_RIGHT, SWC_MARGIN_COLUMNS, SWC_MARGIN_LEFT_RIGHT),
+			NWidget(WWT_EMPTY, COLOUR_GREY, SSW_ICON_PANEL), // Space to display the icons on
+			/* First column 'texts', describing each setting. */
+			NWidget(NWID_VERTICAL), SetPIP(0, SWC_MARGIN_LINES, 0),
+				NWidget(NWID_SPACER), SetMinimalTextLines(1, 0),
+				NWidget(NWID_SELECTION, INVALID_COLOUR, SSW_SELECT_TEXTS),
+					NWidgetFunction(MakeOptionTextsColumn),
+					NWidgetFunction(MakeCompanyTextsColumn),
+				EndContainer(),
+			EndContainer(),
+			/* Second column 'Current settings', showing the current value of each setting */
+			NWidget(NWID_VERTICAL), SetPIP(0, SWC_MARGIN_LINES, 0),
+			NWidget(WWT_LABEL, COLOUR_GREY), SetDataTip(STR_SHARING_CURRENT, STR_NULL),
+				NWidget(NWID_SELECTION, INVALID_COLOUR, SSW_SELECT_CURRENT),
+					NWidgetFunction(MakeOptionCurrentColumn),
+					NWidgetFunction(MakeCompanyCurrentColumn),
+				EndContainer(),
+			EndContainer(),
+			/* Last column 'Future settings', to show and edit the new value of each setting */
+			NWidget(NWID_VERTICAL), SetPIP(0, SWC_MARGIN_LINES, 0),
+				NWidget(WWT_LABEL, COLOUR_GREY), SetDataTip(STR_SHARING_FUTURE, STR_NULL),
+				NWidget(NWID_SELECTION, INVALID_COLOUR, SSW_SELECT_FUTURE),
+					NWidgetFunction(MakeOptionFutureColumn),
+					NWidgetFunction(MakeCompanyFutureColumn),
+				EndContainer(),
+			EndContainer(),
+		EndContainer(),
+		NWidget(NWID_HORIZONTAL), SetPIP(SWC_MARGIN_LEFT_RIGHT, 0, SWC_MARGIN_LEFT_RIGHT),
+			NWidget(WWT_TEXT, COLOUR_GREY, SSW_CHANGES_EFFECT), SetDataTip(STR_JUST_STRING, STR_NULL), SetFill(1, 0),
+		EndContainer(),
+	EndContainer(),
+	NWidget(NWID_HORIZONTAL, NC_EQUALSIZE),
+		NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, SSW_OPTIONS),   SetResize(1, 0),
+							SetDataTip(STR_SHARING_OPTIONS, STR_SHARING_OPTIONS_TOOLTIP), SetFill(1, 0),
+		NWidget(WWT_PUSHTXTBTN, COLOUR_GREY, SSW_COMPANIES), SetResize(1, 0),
+							SetDataTip(STR_SHARING_COMPANIES, STR_SHARING_COMPANIES_TOOLTIP), SetFill(1, 0),
+	EndContainer(),
+};
+
+/** Window description for the sharing settings window. */
+static const WindowDesc _sharing_settings_desc(
+	WDP_AUTO, 0, 0,
+	WC_SHARING_OPTIONS, WC_COMPANY,
+	WDF_UNCLICK_BUTTONS,
+	_nested_sharing_settings_widgets, lengthof(_nested_sharing_settings_widgets)
+);
+
+/**
+ * Show the sharing window of a company.
+ * @param company The company whose window to show.
+ */
+static void ShowCompanySharingSettings(CompanyID company)
+{
+	if ((_settings_game.sharing.sharing_mode == SHARING_INDIVIDUAL) && Company::IsValidID(company)) {
+		AllocateWindowDescFront<SharingSettingsWindow>(&_sharing_settings_desc, company);
+	}
+}
diff -r 779c5a44c6a1 src/depot_gui.cpp
--- a/src/depot_gui.cpp	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/depot_gui.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -29,6 +29,7 @@
 #include "tilehighlight_func.h"
 #include "window_gui.h"
 #include "vehiclelist.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -696,7 +697,7 @@
 
 		/* Setup disabled buttons. */
 		TileIndex tile = this->window_number;
-		this->SetWidgetsDisabledState(!IsTileOwner(tile, _local_company),
+		this->SetWidgetsDisabledState(!IsInfraUsageAllowed(tile, _local_company, this->type),
 			DEPOT_WIDGET_STOP_ALL,
 			DEPOT_WIDGET_START_ALL,
 			DEPOT_WIDGET_SELL,
